% shift_av(y_av,dirac,p_neg,av_neg} computes the average income (wealth) of
% the nonnegative part of the population if there is a share p_neg of the
% population with average negative income (wealth) av_neg.
% If there is a Dirac at dirac, the resulting average is shifted by -dirac.

function [y_av_new] = shift_av(y_av,dirac,p_neg,av_neg)

y_av_new = (y_av-dirac-p_neg.*av_neg)./(1-p_neg);