function [loc_a] = loc_alpha(pp,bb,alpha,alpha0,Npop,b_gperc)

gp1 = linspace(0,0.99,100);
gp2 = linspace(0.991,0.999,9);
gp3 = linspace(0.9991,0.9999,9);
gp4 = linspace(0.99991,0.99999,9);
gperc = [gp1,gp2,gp3,gp4]';

[AA,AA_pr] = alpha_curve(gperc,pp,alpha,alpha0);

loc_a_gperc = AA-(1-gperc).*b_gperc.*AA_pr;
loc_a_gperc = max(min(loc_a_gperc,1),0);

figure
subplot(2,2,1) 
plot(gperc,b_gperc)
title('Pareto curve')
subplot(2,2,2) 
plot(gperc,AA)
title('Alpha curve')
subplot(2,2,3) 
plot(gperc,AA_pr)
title('Derivative of the alpha curve')
subplot(2,2,4)
plot(gperc,loc_a_gperc)
title('Local alpha curve')

interp1(gperc,AA,[0.1; 0.2; 0.3; 0.4; 0.5; 0.6; 0.7; 0.8; 0.9; 0.95; 0.99])

PP=(0:(Npop-1))'/(Npop-1);
loc_a = pchip(gperc,loc_a_gperc,PP);