%% Approximation of the negative part of the population

function y = neg_part(N,thr,mu)

disp('Approximates the negative part')

if ~isnan(thr)
    syms lambda q
    param = solve([1./(lambda.*(1-q))==-thr, 1./(lambda.*(3-2*q))==-mu],[lambda, q]);
    
    syms x
    assume(x,'positive')
    f = (2-param.q)*param.lambda*(1-param.lambda*(1-param.q)*x).^(1/(1-param.q));
    F = 1+int(f,x);
    F_func=matlabFunction(F);
    yy = linspace(0,-thr,100);
    pp = F_func(yy);
    y = -interp1(pp,yy,1-N,'pchip','extrap');
else
    syms p
    Q = mu*log(1-p);
    Q_func=matlabFunction(Q);
    
    y = -Q_func(1-N);
end

disp('Negative part estimated')